<template>
  <aside
    id="sidebar"
    class="kit parts sidebar"
    :class="{ show: actionManager.sidebarShow }">
    <nav class="stack">
      <a
        href="#"
        @click.prevent="hideSidebar"
        class="close">
        <img
          svg-inline
          src="~/assets/svg/header/sidebar/close.svg">
      </a>
      <a
        href="#"
        @click.prevent="setSidebarSection('parts')"
        class="link link-parts mobilshow"
        :class="{ active: actionManager.sidebarSection == 'parts' }">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/header/sidebar/parts-mobile.svg">
        </span>
        <span class="text">Запчасти</span>
      </a>
      <a
        href="#"
        @click.prevent="setSidebarSection('check-auto')"
        class="link link-check mobilshow"
        :class="{ active: actionManager.sidebarSection == 'check-auto' }">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/header/sidebar/check-auto-mobile.svg">
        </span>
        <span class="text">Проверка<br>авто</span>
      </a>
      <a
        href="#"
        @click.prevent="setSidebarSection('helper')"
        class="link link-help new mobilshow"
        :class="{ active: actionManager.sidebarSection == 'helper' }">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/header/sidebar/concierge-mobile.svg">
        </span>
        <span class="text">Автоконсьерж</span>
      </a>

      <flink
        href="/"
        domain="main"
        @mouseover.native="menuParts = true"
        @mouseout.native="menuParts = false"
        @click.native="$ga('Zap','Click18')"
        class="link link-parts desktopshow"
        :class="{ active: navigation === 'parts' }">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/header/sidebar/parts-mobile.svg">
        </span>
        <span class="icon-svg">
          <img
            svg-inline
            src="~/assets/svg/header/sidebar/parts-desktop.svg">
        </span>
        <span class="text">Запчасти</span>
      </flink>

      <flink
        href="/"
        domain="sto"
        @mouseover.native="menuSto = true"
        @mouseout.native="menuSto = false"
        @click.native="$ga('STO','Click19')"
        class="link link-sto desktopshow"
        :class="{ active: domain === $config.domains.sto }">
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/header/sidebar/services-mobile.svg"
            alt="">
        </span>
        <span class="icon-svg">
          <img
            svg-inline
            src="~/assets/svg/header/sidebar/services-desktop.svg"
            alt="">
        </span>
        <span class="text">Автотехцентры</span>
      </flink>

      <flink
        href="/"
        domain="helper"
        @mouseover.native="menuConcierge = true"
        @mouseout.native="menuConcierge = false"
        class="link new link-help desktopshow"
        :class="{ active: domain === $config.domains.helper }">
        <span class="icon-svg">
          <img
            svg-inline
            src="~/assets/svg/header/sidebar/concierge-desktop.svg"
            alt="">
        </span>
        <span class="icon">
          <img
            svg-inline
            src="~/assets/svg/header/sidebar/concierge-mobile.svg"
            alt="">
        </span>
        <span class="text">Автоконсьерж</span>
      </flink>
    </nav>

    <nav class="submenu">
      <div
        class="category"
        :class="{ active: actionManager.sidebarSection == 'parts' }">
        <div class="title">Запчасти</div>
        <nav
          class="links links-parts"
          :class="{ active: menuParts }"
          @mouseover="menuParts = true"
          @mouseout="menuParts = false">
          <flink
            href="/poisk-po-nomeru"
            domain="main"
            class="link"
            active-class="active">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/search.svg">
            </span>
            Поиск по номеру
            <span class="hide-on largescreen"><br> или наименованию</span>
          </flink>
          <flink
            href="/request-to-spare"
            domain="main"
            class="link"
            active-class="active">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/parts/request-to-spare.svg"
                alt="">
            </span>
            Запрос по VIN
          </flink>
          <flink
            href="/catalog"
            domain="main"
            class="link"
            active-class="active">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/parts/catalog-car.svg"
                alt="">
            </span>
            Каталоги запчастей
          </flink>
          <flink
            href="/categories"
            domain="main"
            class="link"
            active-class="active">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/parts/catalog-parts.svg"
                alt="">
            </span>
            Каталог товаров
          </flink>
          <flink
            href="/tyres"
            domain="main"
            class="link"
            active-class="active"
            :class="{ active: $route.path.startsWith('/wheels') }">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/parts/tyres.svg"
                alt="">
            </span>
            Шины/Диски
          </flink>
          <flink
            href="/do/part"
            domain="main"
            class="link pb-1rem"
            active-class="active">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/parts/do.svg"
                alt="">
            </span>
            Контрактные запчасти
          </flink>
        </nav>
      </div>
      <div
        class="category"
        :class="{ active: actionManager.sidebarSection == 'check-auto' }">
        <div class="title">Проверка авто</div>
        <nav class="links">
          <flink
            href="/check-auto"
            domain="main"
            class="link"
            active-class="active">Проверить авто</flink>
          <flink
            href="/check-auto/example"
            domain="main"
            class="link"
            active-class="active">Пример отчета</flink>
          <flink
            href="/check-auto/questions"
            domain="main"
            class="link"
            active-class="active"
            :class="{ active: $route.path.startsWith('/check-auto/report_') }">Вопросы и ответы</flink>
          <flink
            href="/about-us"
            domain="main"
            class="link">Документация</flink>
        </nav>
      </div>
      <div class="category">
        <div class="title">Автотехцентры</div>
        <nav
          class="links links-sto"
          :class="{ active: menuSto }"
          @mouseover="menuSto = true"
          @mouseout="menuSto = false">
          <flink
            href="/search"
            domain="sto"
            class="link">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/search.svg">
            </span>
            Расширенный поиск
          </flink>
          <flink
            href="/request"
            domain="sto"
            class="link">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/services/wallet.svg">
            </span>
            Запросить стоимость ремонта
          </flink>
          <flink
            href="#"
            class="link disable">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/question.svg">
            </span>
            Предварительная диагностика
          </flink>
        </nav>
      </div>
      <div
        class="category"
        :class="{ active: actionManager.sidebarSection === 'helper' }">
        <div class="title">Автоконсьерж</div>
        <nav
          class="links links-concierge"
          :class="{ active: menuConcierge }"
          @mouseover="menuConcierge = true"
          @mouseout="menuConcierge = false">
          <flink
            href="/"
            domain="helper"
            class="link"
            exact-active-class="active">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/concierge/call.svg">
            </span>
            Вызвать автоконсьержа
          </flink>
          <flink
            href="/partner"
            domain="helper"
            class="link"
            active-class="active">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/concierge/partner.svg">
            </span>
            Стать партнером
          </flink>
          <flink
            href="/about"
            domain="helper"
            class="link"
            active-class="active">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/concierge/info.svg">
            </span>
            О сервисе
          </flink>
          <flink
            href="/faq/help-finding-parts"
            domain="helper"
            class="link"
            active-class="active">
            <span class="icon-svg hide-on smallscreen">
              <img
                svg-inline
                src="~/assets/svg/header/sidebar/submenu/question.svg">
            </span>
            FAQ
          </flink>
        </nav>
      </div>
    </nav>
    <div class="shadow"/>
  </aside>
</template>

<script>
import { createNamespacedHelpers, mapState } from 'vuex';
import { HIDE_SIDEBAR, SET_SIDEBAR_SECTION } from '~/assets/js/store/actionManager/mutation-types';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
export default {
  name: 'Sidebar',
  data() {
    return {
      menuParts: false,
      menuSto: false,
      menuConcierge: false,
    };
  },
  computed: {
    ...mapState(['actionManager', 'navigation', 'domain']),
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      hideSidebar: HIDE_SIDEBAR,
      setSidebarSection: SET_SIDEBAR_SECTION,
    }),
  },
};
</script>

<style lang="scss" scoped>
$sidebar-width: 6.25rem;

@mixin ViewSidebarLeft() {
  width: 100px;
  right: auto;
  top: 0;
  bottom: 0;
  left: 0;
  background: #fff;
  position: fixed;
  height: auto;
  display: flex !important;
  justify-content: center;
  &.parts {
    & > .stack {
      background: #fff;
      padding-bottom: 6.5rem;
    }
  }
  & > .submenu {
    display: none;
    visibility: hidden;
    opacity: 0;
    height: 0;
    max-height: 0;
    max-width: 0;
  }
  & > .stack{
    display: flex;
    flex-flow: column;
    justify-content: center;
    width: 100%;
    min-height: 100%;
    .link {
      display: flex;
      flex-flow: column nowrap;
      color: #212529;
      padding: 2.5rem 0;
      align-items: center;
      height: auto;
      background-color: #E8F0F9 !important;
      &:hover {
        background-color: #D0E0F3 !important;
      }
      &.new {
        padding-right: 0;
        &:before {
          font-size: 0.5625rem ;
          top: 0.75rem;
          right: .75rem;
          margin-top: 0;
          transform: scale(1.3);
        }
      }
      // &:hover {
      //   background-color: #f6faff;
      //   color: #272727;
      //   text-decoration: none;
      //   transition: .2s ease all;
      // }
      &.active {
        background-color: #D0E0F3 !important;
        pointer-events: none;
      }
      .icon {
        height: 3rem;
        .svg {
          width: 3.125rem;
          height: 3rem;
          fill: #212529;
        }
      }
      .text {
        display: block;
        font-weight: 500;
        margin-top: 0.8125rem;
        line-height: 1.25;
        font-size: 0.6875rem;
        margin-left: 0;
        color: #141414;
      }
      &.disable {
        opacity: .5;
        pointer-events: none;
      }
    }
  }
}

.kit.main.header.theme.purpur .kit.parts.sidebar {
  $colorIconSubmenuPurpur: #842c2d;
  $colorTextHoverSubmenuPurpur: #842c2d;
  $colorBgHoverSubmenuPurpur: #fff3f7;
  @media only screen and (min-width: 1025px) {
    > .submenu {
      .link .icon .svg {
        fill: $colorIconSubmenuPurpur;
      }
      .icon-svg .svg{
        fill: $colorIconSubmenuPurpur;
      }
      .link:hover {
        background-color: $colorBgHoverSubmenuPurpur;
        color: $colorTextHoverSubmenuPurpur;
      }
    }
  }
}

.kit.main.header.theme.aquamarin .kit.parts.sidebar {
  $colorIconSubmenuPurpur: #0d6187;
  $colorTextHoverSubmenuPurpur: #0d6187;
  $colorBgHoverSubmenuPurpur: #f6faff;
  @media only screen and (min-width: 1025px) {
    > .submenu {
      .link .icon .svg {
        fill: $colorIconSubmenuPurpur;
      }
      .icon-svg .svg{
        fill: $colorIconSubmenuPurpur;
      }
      .link:hover {
        background-color: $colorBgHoverSubmenuPurpur;
        color: $colorTextHoverSubmenuPurpur;
      }
    }
  }
}

.kit.parts.sidebar {
  $colorIconSubmenu: #4272a4;
  $colorTextHoverSubmenu: #4272a4;
  $colorBgHoverSubmenu: #f6faff;

  position: fixed;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  z-index: 1000;
  display: flex !important;
  flex-flow: row nowrap;
  font-size: 1rem;
  transform-origin: 0 50% 0;
  transform: translateX(-150%) scaleX(1.5);
  transition: transform .4s ease;
  pointer-events: none;
  &.show {
    transform: translateX(0) !important;
    pointer-events: all;
    & > .stack {
      box-shadow: 30px 0 120px 0 rgba(96, 126, 146, .15);
    }
  }
  & > .stack {
    width: 6.25rem;
    flex: 0 0 6.25rem;
    text-align: center;
    background: #fff;
    z-index: 2;
    @media only screen and (min-width: 1200px) {
      display: flex;
      width: auto;
      flex: 1 1 auto;
      background-color: transparent;
    }

    & > .close {
      display: flex;
      width: 100%;
      padding: 1rem 0;
      .svg {
        display: block;
        margin: auto;
        width: 1.125rem;
        height: 1.125rem;
        fill: #212529;
      }
      @media only screen and (min-width: 1200px) {
        display: none;
      }
    }

    .link {
      display: flex;
      flex-flow: column nowrap;
      color: #212529;
      padding: 1rem 0;
      &.new {
        padding-right: 0;
        @media only screen and (min-width: 1200px) {
          padding-right: 3.5rem;
        }
        &:before {
          top: 0.75rem;
          right: .75rem;
          margin-top: 0;
          transform: scale(1.3);
          @media only screen and (max-width: 1024px) {
            top: 0.25rem;
            right: 0.25rem;
            transform: none;
          }
          @media only screen and (min-width: 1200px) {
            top: 50%;
            right: 1.5rem;
            margin-top: -0.75rem;
          }
        }
      }

      @media only screen and (min-width: 1200px) {
        flex-flow: row nowrap;
        align-items: center;
        height: 4.5rem;
        padding:0 0.75rem;
        color: hsla(0, 0%, 100%, .85);
      }
      &:hover {
        background-color: #f6faff;
        color: #272727;
        text-decoration: none;
        transition: .2s ease all;
        @media only screen and (min-width: 1200px) {
          background-color: rgba(255, 255, 255, 0.25);
          color: #fff;
        }
      }
      &.active {
        background: #ffcf68;
        &:hover {
          background: #ffcd46;
        }
        @media only screen and (min-width: 1200px) {
          background-color: rgba(255, 255, 255, 0.08);
          color: #fff;
          &:hover {
            background-color: rgba(255, 255, 255, 0.25);
            color: #fff;
          }
        }
      }
      .icon {
        display: none;
        @media only screen and (min-width: 1200px) {
          height: 1.5rem;
        }
        @media only screen and (max-width: 1024px) {
          display: block;
          font-size: 0;
          line-height: 0;
          .svg {
            height: 3.25rem;
            width: auto;
            fill: #212529;
          }
        }
      }
      .icon-svg {
        width: 1.5rem;
        .svg {
          fill: #ffffff;
        }
      }
      .text {
        display: block;
        font-size: .75rem;
        font-weight: 500;
        margin-top: .5rem;
        line-height: 1.25;
        @media only screen and (min-width: 1200px) {
          font-size:0.875rem;
          margin-left: 0.625rem;
          margin-top: 0;
        }
      }
      &.disable {
        opacity: .5;
        pointer-events: none;
      }
    }
  }

  & > .submenu {
    flex: 1 1 auto;
    transition: transform .8s ease;
    position: relative;
    background: #fff;
    z-index: 1;
    //transform: perspective(100vw) rotate3d(0, 1, 0, 15deg);
    transform-origin: 0 50%;
    @media only screen and (min-width: 1200px) {
      display: flex;
      flex-grow: 0;
      position: absolute;
      top: 100%;
      left: 0;
    }
    & > .category {
      padding: 1.5rem 0 1rem;
      transition: top .5s ease;
      position: absolute;
      width: 100%;
      top: -100vh;
      @media only screen and (min-width: 1200px) {
        top: 0;
        padding: 0;
        left: 0;
        width: auto;
        &.submenu-sto {
          left: 154px;
        }
      }
      & > .title {
        line-height: 1.2;
        color: #272727;
        font-weight: 700;
        margin: 0 0 1rem;
        padding: 0 2.25rem;
        font-size: 1.5rem;
        @media only screen and (min-width: 1200px) {
          display: none;
        }
      }
    }
    & > .category.active {
      top: 0;
      & ~ .category {
        @media only screen and (min-width: 1025px) {
          top: 0;
        }
      }
    }
    & > .category.show {
      @media only screen and (min-width: 1200px) {
        > .links {
          display: block;
        }
      }
    }

    .links {
      width: 100%;
      @media only screen and (min-width: 1200px) {
        display: none;
        background-color: #fff;
        box-shadow: 0 3px 6px rgba(0, 0, 0, 0.16);
        &.active {
          display: block;
        }
        &.links-sto {
          left: 121px;
          position: relative;
        }
        &.links-concierge {
          left: 280px;
          position: relative;
        }
      }
    }
    .link {
      display: block;
      width: 100%;
      border-bottom: 1px solid #dbe4e9;
      padding: .75rem 2.25rem;
      color: #515f68;
      font-size: 0.875rem;
      line-height: 1.5;
      font-weight: 500;
      &:hover {
        background-color: $colorBgHoverSubmenu;
        color: #272727;
        text-decoration: none;
      }
      @media only screen and (min-width: 1200px) {
        color: #4a4a4a;
        font-size: 0.8125rem;
        font-weight: 400;
        line-height: 1.5rem;
        padding: 0.5rem 1.5rem;
        border: none;
        display: flex;
        align-items: center;
        white-space: nowrap;
        &:hover {
          color: $colorTextHoverSubmenu;
          background-color: #f6faff;
        }
        &:first-child {
          padding-top: 1rem;
        }
        &:last-child {
          padding-bottom: 1rem;
        }
        &.pb-1rem {
          padding-bottom: 1rem;
        }
      }
      &.active {
        color: $colorIconSubmenu;
        background-color: #f6faff;
      }
      &.disable {
        opacity: .5;
        pointer-events: none;
      }
    }
  }

  *.new {
    position: relative;
    &:before {
      position: absolute;
      content: 'new';
      font-size: 0.4220rem;
      width: 1.2rem;
      height: 1.2rem;
      border-radius: 50%;
      background: #f37c7c;
      color: #fff;
      display: flex;
      justify-content: center;
      align-items: center;
      right: -1.25rem;
      top: 0.375rem;
      line-height: 0.625rem;
    }
  }

  @media only screen and (min-width: 1025px) {
    position: relative;
    display: inline-flex;
    top: auto;
    right: auto;
    bottom: auto;
    left: auto;
    flex-flow: column nowrap;
    transform: translateX(0);
    pointer-events: all;
  }

  @media (min-width: 1025px) and (max-width: 1199px) {
    transform: translateX(-150%) scaleX(1.5);
    transition: transform .4s ease;
    &.show .shadow {
      position: fixed;
      width: 100vw;
      top: 0;
      bottom: 0;
      left: 0;
      right: 0;
      background-color: rgba(0, 0, 0, 0.5);
      transition: 0.3s ease all;
    }
    & > .submenu {
      display: none;
      visibility: hidden;
      opacity: 0;
      height: 0;
      max-height: 0;
      max-width: 0;
    }
    & > .stack > .close {
      margin: 0 0 auto;
      display: block;
    }
    & > .stack .link:nth-child(2) {
      margin-top: -6.25vh;
    }

    & > .stack .link:last-child {
      margin-bottom: auto;
    }

    & > .stack .link {
      .icon {
        display: block;
      }
      .icon-svg {
        display: none;
      }
    }
    @include ViewSidebarLeft();
  }

  &.index {
    > .stack {
      box-shadow: 30px 0 120px 0 rgba(96, 126, 146, .15);
    }
    > .stack .link {
      .icon {
        display: block;
      }
      .icon-svg {
        display: none;
      }
    }
    @media only screen and (min-width: 1200px) {
      transform: translateX(0);
      pointer-events: all;
      @include ViewSidebarLeft();
    }
  }
  &.cabinet {
    @media only screen and (min-width: 1200px) {
      > .stack .link {
        height: auto;
      }
    }
  }


  .location {
    &-link {
      display: flex;
      flex-flow: row nowrap;
      align-items: center;
      font-size: .95rem;
      color: text-color('dark') !important;
      font-weight: 400;
      white-space: nowrap;
      &:hover,
      &:focus,
      &.active {
        text-decoration: none;
        color: text-color('link') !important;
      }
      &-flag {
        display: inline-block;
        width: 1rem;
        height: .75rem;
        margin-right: .5rem;
        background: #C5D1D9;
        img{
          display: block;
        }
      }
      &-text {
        position: relative;
        padding-right: 1rem;
        line-height: 1;
        white-space: nowrap;
      }
    }
  }

  .icon-svg {
    display: inline-flex;
    justify-content: flex-start;
    align-items: center;
    width: 2rem;
    .svg {
      fill: $colorIconSubmenu;
    }
  }
}
</style>
